<template>
  <div class="cart">
    <h1 class="title">Товары:</h1>
    <div class="product" v-for="( product, index ) in cart" :key="index">
      <div class="text">{{product.typeName}}&nbsp;&mdash;&nbsp;</div>
      <div class="text">{{product.modelName}}&nbsp;&mdash;&nbsp;</div>
      <div v-if="product.submodelName !== ''" class="text">{{product.submodelName}}&nbsp;&mdash;&nbsp;</div>
      <div class="text">{{product.materialName}}&nbsp;&mdash;&nbsp;</div>
      <div class="text">{{product.width}}x{{product.height}}&nbsp;&mdash;&nbsp;</div>
      <div class="text">{{product.result}}руб</div>
      <button class="delete" @click="remove(index)">Удалить</button>
    </div>
    <div class="text">Общая стоимость: {{cartTotal}}руб</div>
    <a class="order" :href="buttonLink" @click="order">Оформить заказ</a>
    <router-link class="link" to="/">На главную</router-link>
  </div>
</template>
<script>
import { mapState, mapActions, mapMutations } from 'vuex'

export default {
  name: 'Cart',
  data() {
    return {
      buttonLink: "javascript:void(0)"
    }
  },
  computed: {
    ...mapState({
      cart: state => state.models.cart
    }),
    cartTotal() {
      let totalPrice = 0;
      for (let i = 0; i < this.cart.length; i++) {
        totalPrice += this.cart[i].result;
      }
      return (Math.round(totalPrice * 100) / 100);
    }
  },
  methods: {
    ...mapActions('models', [
      'sendOrder' 
    ]),
    ...mapMutations('models', [
      'removeFromCart'
    ]),
    remove(index) {
      this.removeFromCart(index);
      if (this.cart.length > 0) {
        this.buttonLink = "javascript:void(0)";
      } else {
        this.buttonLink = "/";
      }
    },
    order() {
      let items = [];
      let options = [];
      for (let i = 0; i < this.cart.length; i++) {
        options.push({
          value: this.cart[i].options,
          code_1c: this.cart[i].codes
        })
        items.push({
          type: {
            name: this.cart[i].typeName,
            id: this.cart[i].typeId,
          },
          model: {
            name: this.cart[i].modelName,
            id: this.cart[i].modelId,
            sub: {
              name: this.cart[i].submodelName,
              id: this.cart[i].submodelId,
            }
          },
          options: this.cart[i].options,
          width: this.cart[i].width,
          height: this.cart[i].height,
        });
      }
      this.sendOrder(items);
    }
  }
}
</script>
<style>
.cart {
  display: block;
  width: 100%;
  max-width: 1000px;
  padding: 60px 20px 20px;
}
.title {
  font-size: 24px;
  line-height: 28px;
  margin: 0 0 20px;
}
.product {
  display: flex;
  width: calc(100% + 16px);
  margin: 0 0 8px;
}
.text {
  display: block;
  font-size: 16px;
  line-height: 20px;
  color: #000;
}
.delete {
  font-size: 14px;
  height: 22px;
  margin: 0 0 0 auto;
  cursor: pointer;
}
.order {
  display: block;
  width: 220px;
  height: 40px;
  font-size: 18px;
  line-height: 38px;
  text-align: center;
  text-decoration: none;
  text-transform: uppercase;
  letter-spacing: 1px;
  color: #fff;
  border: 1px solid #000;
  border-radius: 0;
  background-color: #000;
  margin: 24px 0 0;
  padding: 0;
  transition: 0.3s;
  cursor: pointer;
}
.order:hover {
  color: #000;
  background-color: #fff;
}
.link {
  position: absolute;
  top: 20px;
  left: auto;
  right: 20px;
  font-size: 16px;
  line-height: 20px;
  text-decoration: none;
  color: #000;
  transition: 0.3s;
  z-index: 1;
}
.link:hover {
  color: #539fbb;
}
</style>